unit TestImage;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ImgList,
  ExtCtrls;

type

  { TTestImage }

  TTestImage = class(TCustomControl)
  private
    FImageIndex: TImageIndex;
    FImageList: TImageList;
    procedure SetImageIndex(AValue: TImageIndex);
    procedure SetImageList(AValue: TImageList);

  protected

  public
   constructor Create(AOwner: TComponent); override;
   destructor  Destroy; override;
   procedure   Paint; override;
  published
   property ImageIndex : TImageIndex read FImageIndex write SetImageIndex default -1;
   property Images  : TImageList read FImageList write SetImageList;

  end;

procedure Register;

implementation

procedure Register;
begin
  {$I testimage_icon.lrs}
  RegisterComponents('Standard',[TTestImage]);

end;

{ TTestImage }

procedure TTestImage.SetImageIndex(AValue: TImageIndex);
begin
  if FImageIndex=AValue then Exit;
  FImageIndex:=AValue;
end;

procedure TTestImage.SetImageList(AValue: TImageList);
begin
  if FImageList=AValue then Exit;
  FImageList:=AValue;

end;

constructor TTestImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

end;

destructor TTestImage.Destroy;
begin
  inherited Destroy;
end;

procedure TTestImage.Paint;
var aImage : TImage;
begin
  inherited Paint;
  canvas.Brush.Color:=clWhite;
  canvas.FillRect(0,0,width,height);
  aImage := TImage.Create(nil);
  Images.DrawForControl(canvas,2,2,FImageIndex,16,aImage,true);
  aImage.Free;
end;

end.
